﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
      using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Modules;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    using static Eco.Gameplay.Housing.HousingValue;

    [Serialized]
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(LinkComponent))]
    [RequireComponent(typeof(PublicStorageComponent))]
    [RequireComponent(typeof(HousingComponent))]
    [RequireComponent(typeof(SolidGroundComponent))]
    public partial class SaltBasketObject :
        WorldObject,
        IRepresentsItem
    {
        public override LocString DisplayName { get { return Localizer.DoStr("Salt Basket"); } }

        public virtual Type RepresentedItemType { get { return typeof(SaltBasketItem); } }



        protected override void Initialize()
        {

            var storage = this.GetComponent<PublicStorageComponent>();
            storage.Initialize(6);
            this.GetComponent<HousingComponent>().Set(SaltBasketItem.HousingVal);

        }

        public override void Destroy()
        {
            base.Destroy();
        }

    }

    [Serialized]
    [LocDisplayName("Salt Basket")]
    [Ecopedia("Housing Objects", "Kitchen", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]
    [Tag("Housing", 1)]
    public partial class SaltBasketItem :
        WorldObjectItem<SaltBasketObject>
    {
        public override LocString DisplayDescription => Localizer.DoStr("A basket of salt with 6 storage.");

        static SaltBasketItem()
        {

        }

        [TooltipChildren] public HousingValue HousingTooltip { get { return HousingVal; } }
        [TooltipChildren] public static HousingValue HousingVal { get { return new HousingValue()
                                                {
                                                    Category = RoomCategory.Kitchen,
                                                    Val = 1.5f,
                                                    TypeForRoomLimit = "Spices",
                                                    DiminishingReturnPercent = 0.4f
        };}}


    }

    [RequiresSkill(typeof(FarmingSkill), 3)]
    public partial class SaltBasketRecipe :
        RecipeFamily
    {
        public SaltBasketRecipe()
        {
            var product = new Recipe(
                "SaltBasket",
                Localizer.DoStr("Salt Basket"),
                new IngredientElement[]
                {
               new IngredientElement("WoodBoard", 20, typeof(FarmingSkill), typeof(FarmingLavishResourcesTalent)),
                },
               new CraftingElement<SaltBasketItem>()
            );
            this.Recipes = new List<Recipe> { product };
            this.ExperienceOnCraft = 3;
            this.LaborInCalories = CreateLaborInCaloriesValue(160, typeof(FarmingSkill));
            this.CraftMinutes = CreateCraftTimeValue(typeof(SaltBasketRecipe), 2, typeof(FarmingSkill), typeof(FarmingFocusedSpeedTalent), typeof(FarmingParallelSpeedTalent));
            this.Initialize(Localizer.DoStr("Salt Basket"), typeof(SaltBasketRecipe));
            CraftingComponent.AddRecipe(typeof(FarmersTableObject), this);
        }
    }
}
